Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr
Class QuantifiedExpression

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.Assignation
              net.sf.saxon.expr.QuantifiedExpression

All Implemented Interfaces:
  Serializable, SourceLocator, LocationProvider, SaxonLocator, Binding, InstructionInfo, Locator

    public class QuantifiedExpression

extends Assignation

A QuantifiedExpression tests whether some/all items in a sequence satisfy some condition.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.Assignation
`action, requiredType, sequence, slotNumber, variableName`

Fields inherited from class net.sf.saxon.expr.Expression
`EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, EVENT_FEED_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, PROCESS_METHOD, PUSH_SELECTION, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, WATCH_METHOD`

Constructor Summary
`QuantifiedExpression()`

Method Summary
`void` | `checkForUpdatingSubexpressions()` Check to ensure that this expression does not contain any updating subexpressions.
`int` | `computeCardinality()` Determine the static cardinality
`int` | `computeSpecialProperties()` Determine the special properties of this expression
`Expression` | `copy()` Copy an expression.
`boolean` | `effectiveBooleanValue(XPathContext context)` Get the result as a boolean
`Item` | `evaluateItem(XPathContext context)` Evaluate the expression to return a singleton value
`void` | `explain(ExpressionPresenter out)` Diagnostic print of expression structure.
`String` | `getExpressionName()` Get a name identifying the kind of expression, in terms meaningful to a user.
`ItemType` | `getItemType(TypeHierarchy th)` Determine the data type of the items returned by the expression
`int` | `getOperator()` Get the operator, either `Token.SOME` or `Token.EVERY`
`boolean` | `hasLoopingSubexpression(Expression child)` Given an expression that is an immediate child of this expression, test whether the evaluation of the parent expression causes the child expression to be evaluated repeatedly
`boolean` | `isUpdatingExpression()` Determine whether this is an updating expression as defined in the XQuery update specification
`Expression` | `optimize(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`void` | `setOperator(int operator)` Set the operator, either `Token.SOME` or `Token.EVERY`
`String` | `toString()` The toString() method for an expression attempts to give a representation of the expression in an XPath-like form, but there is no guarantee that the syntax will actually be true XPath.
`Expression` | `typeCheck(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Type-check the expression

Methods inherited from class net.sf.saxon.expr.Assignation
`addReference, addToPathMap, evaluateVariable, extendBindingList, getAction, getIntegerBoundsForVariable, getLocalSlotNumber, getNominalReferenceCount, getObjectName, getRequiredSlots, getRequiredType, getSequence, getVariableName, getVariableQName, hasVariableBinding, isAssignable, isGlobal, isIndexedVariable, iterateSubExpressions, promote, promoteWhereClause, refineTypeInformation, replaceSubExpression, replaceVariable, setAction, setIndexedVariable, setRequiredType, setSequence, setSlotNumber, setVariableQName, simplify, suppressValidation`

Methods inherited from class net.sf.saxon.expr.Expression
`adoptChildExpression, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, dynamicError, evaluateAsString, evaluatePendingUpdates, explain, getCardinality, getColumnNumber, getColumnNumber, getConstructType, getContainer, getDependencies, getEvaluationMethod, getExecutable, getHostLanguage, getImplementationMethod, getIntegerBounds, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, implementsStaticTypeCheck, isSubtreeExpression, isVacuousExpression, iterate, iterateEvents, iterateSameFocusSubExpressions, markTailFunctionCalls, process, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, staticTypeCheck, typeError`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### QuantifiedExpression

    public QuantifiedExpression()

Method Detail

### getExpressionName

    public String getExpressionName()

  Get a name identifying the kind of expression, in terms meaningful to a user.

  Overrides:
    `getExpressionName` in class `Expression`
  Returns:
    a name identifying the kind of expression, in terms meaningful to a user. The name will always be in the form of a lexical XML QName, and should match the name used in explain() output displaying the expression.

### setOperator

    public void setOperator(int operator)

  Set the operator, either `Token.SOME` or `Token.EVERY`

  Parameters:
    `operator` - the operator

### getOperator

    public int getOperator()

  Get the operator, either `Token.SOME` or `Token.EVERY`

  Returns:
    the operator

### computeCardinality

    public int computeCardinality()

  Determine the static cardinality

  Specified by:
    `computeCardinality` in class `Expression`
  Returns:
    the computed cardinality, as one of the values `StaticProperty.ALLOWS_ZERO_OR_ONE`, `StaticProperty.EXACTLY_ONE`, `StaticProperty.ALLOWS_ONE_OR_MORE`, `StaticProperty.ALLOWS_ZERO_OR_MORE`

### typeCheck

    public Expression typeCheck(ExpressionVisitor visitor,
                                ExpressionVisitor.ContextItemType contextItemType)
                         throws XPathException

  Type-check the expression

  Overrides:
    `typeCheck` in class `Expression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### optimize

    public Expression optimize(ExpressionVisitor visitor,
                               ExpressionVisitor.ContextItemType contextItemType)
                        throws XPathException

  Perform optimisation of an expression and its subexpressions.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `Expression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### checkForUpdatingSubexpressions

    public void checkForUpdatingSubexpressions()
                                        throws XPathException

  Check to ensure that this expression does not contain any updating subexpressions. This check is overridden for those expressions that permit updating subexpressions.

  Overrides:
    `checkForUpdatingSubexpressions` in class `Assignation`
  Throws:
    `XPathException` - if the expression has a non-permitted updateing subexpression

### isUpdatingExpression

    public boolean isUpdatingExpression()

  Determine whether this is an updating expression as defined in the XQuery update specification

  Overrides:
    `isUpdatingExpression` in class `Assignation`
  Returns:
    true if this is an updating expression

### copy

    public Expression copy()

  Copy an expression. This makes a deep copy.

  Specified by:
    `copy` in class `Expression`
  Returns:
    the copy of the original expression

### hasLoopingSubexpression

    public boolean hasLoopingSubexpression(Expression child)

  Given an expression that is an immediate child of this expression, test whether the evaluation of the parent expression causes the child expression to be evaluated repeatedly

  Overrides:
    `hasLoopingSubexpression` in class `Expression`
  Parameters:
    `child` - the immediate subexpression
  Returns:
    true if the child expression is evaluated repeatedly

### computeSpecialProperties

    public int computeSpecialProperties()

  Determine the special properties of this expression

  Overrides:
    `computeSpecialProperties` in class `Expression`
  Returns:
    `StaticProperty.NON_CREATIVE`.

### evaluateItem

    public Item evaluateItem(XPathContext context)
                      throws XPathException

  Evaluate the expression to return a singleton value

  Overrides:
    `evaluateItem` in class `Expression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### effectiveBooleanValue

    public boolean effectiveBooleanValue(XPathContext context)
                                  throws XPathException

  Get the result as a boolean

  Overrides:
    `effectiveBooleanValue` in class `Expression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the effective boolean value
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Determine the data type of the items returned by the expression

  Specified by:
    `getItemType` in class `Expression`
  Parameters:
    `th` - the type hierarchy cache
  Returns:
    Type.BOOLEAN

### toString

    public String toString()

  The toString() method for an expression attempts to give a representation of the expression in an XPath-like form, but there is no guarantee that the syntax will actually be true XPath. In the case of XSLT instructions, the toString() method gives an abstracted view of the syntax

  Overrides:
    `toString` in class `Expression`
  Returns:
    a representation of the expression as a string

### explain

    public void explain(ExpressionPresenter out)

  Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.

  Specified by:
    `explain` in class `Expression`
  Parameters:
    `out` - the expression presenter used to display the structure

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.